﻿using UnityEngine;
using System.Collections;

public class Level2Script : MonoBehaviour {

	public GUISkin guiSkin;

	//LEVEL 2 SWITCH
	private bool is_loot_screwdriver = false;
	private int count_switch = 0;
	private bool is_loot_complete = false;

	private GameObject item;
	private PlayerPhysics playerPhysics;
	private GameSettings gameSettings;
	private LevelTimer levelTimer;
	
	private GameObject Btn_InstructionFindAC;
	private ClickButton Btn_ClickButton;
	
	private const string FAILED_BAG = "FAILED ! THE BAG WAS BURNED."; // NOT USED IN LEVEL 2
	private const string FAILED_TIME = "FAILED ! DIED TOO MUCH CARBON DIOXIDE.";
	private const string FAILED_INCOMPLETE = "FAILED ! CANT OPEN DOOR."; // NOT USED IN LEVEL 2
	private const string FAILED_WRONGDOOR = "FAILED ! WRONG DOOR."; 
	private string failedMessage = "";
	
	private bool showDialog_001;
	private bool showDialog_002;
	private bool IsPlayerOutside = true;
	
	private bool showButton_FindAC;

	private bool showWarningDialog_001;
	private bool showFailedMessage;

	void Start () {
		
		playerPhysics = gameObject.GetComponent<PlayerPhysics> ();
		gameSettings = gameObject.GetComponent<GameSettings> ();
		levelTimer = gameObject.GetComponent<LevelTimer>();
		

		if (IsPlayerOutside){
			showDialog_001 = true;
		}	
	}

	void Update () {
		
		GameObject item = playerPhysics.Item;
			
		failedMessage = TimeInteraction();

		if (!IsPlayerOutside && item != null) {

			if (!gameSettings.IsPaused){
			failedMessage = failedMessage + ItemInteraction (item, Input.GetMouseButtonDown (0));
			}
			
		} else if (IsPlayerOutside && item != null) {
			
			if (Input.GetMouseButtonDown (0) && item.tag == "door"){
				
				StartCoroutine(DialogSequence());
			}
		}

		//RESTART ON EVERY FAILED MOVE
		if (failedMessage != "") {
			gameSettings.IsPaused = true;
			showFailedMessage = true;
		}

		if ((item == null || item.name != "loot_fuse"))showWarningDialog_001 = false;
	}
	
	IEnumerator DialogSequence()
	{
		showDialog_001 = false;
		yield return new WaitForSeconds(1.5f);
		IsPlayerOutside = false;
		showDialog_002 = true;
		yield return new WaitForSeconds(2);
		showDialog_002 = false;
		showButton_FindAC = true;
		gameSettings.IsPaused = !gameSettings.IsPaused;
	}
	
	private string TimeInteraction(){
		
		string failedMessage = "";
		
		//GET LOOT BAG IN X SECONDS
		if(levelTimer.GetTimeLapse == (int)levelTimer.SetTimeLimit) {

			failedMessage = FAILED_TIME;
		}
		
		return failedMessage;
	}
	
	
	private string ItemInteraction(GameObject item, bool isClicked){
		
		string failedMessage = "";
		
		if (isClicked) {
			if (item.tag == "loot") {
					DestroyItemLoot (item);
			}
			if (item.tag == "door") {

					//INDOOR
					if (is_loot_complete) {
							Debug.Log ("OPEN DOOR");
							Application.LoadLevel (gameSettings.LEVEL3);
					}
			}
		} else {
				if (!is_loot_screwdriver && item.name == "loot_fuse") {
						showWarningDialog_001 = true;
						//EDIT
						//VOICE OVER
				}
		}
		
		return failedMessage;
	}
	
	
	private void DestroyItemLoot(GameObject item){
		
		if (item.name == "loot_fuse" && !is_loot_screwdriver) {
			//EDIT
			//PLAY SOUND, CANT TURN OFF FUSE
			//Debug.Log("LOOK FOR SCREW D");
		} else {
			
			count_switch += 1;
			Destroy(item);
			
			if (item.name == "loot_screwdriver") {
				count_switch -= 1;
				is_loot_screwdriver = true;
			}
			
			if (count_switch == 4) {
				//EDIT
				//PLAY SOUND, MY AC PA RIN, UBO UBO PA RIN
			}
		}
		
	
		is_loot_complete = (count_switch == 5 && is_loot_screwdriver ) ? true : false;
	}
	
	void OnGUI(){
	
		GUI.skin = guiSkin;
		
		int y = Screen.height - 40;
		int w = Screen.width;
		int h = 50;
		
		
		if (showDialog_001)
			GUI.Label(new Rect(0, y, w, h), "Finally I managed to get out at the theater but that is so weird. \n Why there's an explosion and where did they go?");
		
		if (showDialog_002)
			GUI.Label(new Rect(0, y, w, h), "But It's seems like the temperature in this room it's different and the door was locked.");
		
		int buttonWidth = 400;
		int xCenter = (Screen.width / 2 - buttonWidth / 2);
		
		if (showButton_FindAC) {
			bool ans = GUI.Button(new Rect(xCenter, 220, buttonWidth, 200), "There is something wrong in the\nTemperature in this room\n\nClick To Continue");
			if (ans){
				showButton_FindAC = false;
				levelTimer.DoCountdown = true;
				gameSettings.IsPaused = !gameSettings.IsPaused;
			}
		}

		if (showWarningDialog_001) {
			GUI.Label(new Rect(0, y, w, h), "adsasdadadasd");
		}

		if (showFailedMessage) {
			bool ans = GUI.Button(new Rect(xCenter, 250, buttonWidth, 130), failedMessage);
			if (ans){
				Application.LoadLevel (gameSettings.LEVEL2);
			}
		}
	}

}